> For the complete documentation index, see [llms.txt](https://docs.feast.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.feast.dev/v0.63-branch/reference/data-sources/clickhouse.md).

# Clickhouse (contrib)

## Description

Clickhouse data sources are Clickhouse tables or views. These can be specified either by a table reference or a SQL query.

## Disclaimer

The Clickhouse data source does not achieve full test coverage. Please do not assume complete stability.

## Examples

Defining a Clickhouse source:

```python
from feast.infra.offline_stores.contrib.clickhouse_offline_store.clickhouse_source import (
    ClickhouseSource,
)

driver_stats_source = ClickhouseSource(
    name="feast_driver_hourly_stats",
    query="SELECT * FROM feast_driver_hourly_stats",
    timestamp_field="event_timestamp",
    created_timestamp_column="created",
)
```

The full set of configuration options is available [here](https://rtd.feast.dev/en/master/#feast.infra.offline_stores.contrib.clickhouse_offline_store.clickhouse_source.ClickhouseSource).

## Supported Types

Clickhouse data sources support all eight primitive types and their corresponding array types. The support for Clickhouse Decimal type is achieved by converting it to double. For a comparison against other batch data sources, please see [here](/v0.63-branch/reference/data-sources/overview.md#functionality-matrix).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.feast.dev/v0.63-branch/reference/data-sources/clickhouse.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
